commit 7eba12bf26487ef242fcd833bee6d81a1f5e3bb3
Author: freddy77 <freddy77>
Date:   Thu Aug 20 17:53:06 2009 +0000

    pass raw collation structure to tds_iconv_from_collate

diff --git a/ChangeLog b/ChangeLog
index ed5b821..2269500 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu Aug 20 19:52:58 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/tds/iconv.c src/tds/token.c:
+	- pass raw collation structure to tds_iconv_from_collate
+
 Thu Aug 20 19:51:40 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h: small fix for ms xml type
 
@@ -1761,4 +1765,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2851 2009/08/20 17:51:46 freddy77 Exp $
+$Id: ChangeLog,v 1.2852 2009/08/20 17:53:06 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 9c7b094..a85315c 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.318 2009/08/20 17:51:46 freddy77 Exp $ */
+/* $Id: tds.h,v 1.319 2009/08/20 17:53:06 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1440,7 +1440,7 @@ void tds_srv_charset_changed(TDSSOCKET * tds, const char *charset);
 void tds7_srv_charset_changed(TDSSOCKET * tds, int sql_collate, int lcid);
 int tds_iconv_alloc(TDSSOCKET * tds);
 void tds_iconv_free(TDSSOCKET * tds);
-TDSICONV *tds_iconv_from_collate(TDSSOCKET * tds, int sql_collate, int lcid);
+TDSICONV *tds_iconv_from_collate(TDSSOCKET * tds, TDS_UCHAR collate[5]);
 
 /* threadsafe.c */
 char *tds_timestamp_str(char *str, int maxlen);
diff --git a/src/tds/iconv.c b/src/tds/iconv.c
index 42645d7..cfe6a4e 100644
--- a/src/tds/iconv.c
+++ b/src/tds/iconv.c
@@ -49,7 +49,7 @@
 /* define this for now; remove when done testing */
 #define HAVE_ICONV_ALWAYS 1
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.139 2009/06/17 17:07:31 freddy77 Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.140 2009/08/20 17:53:06 freddy77 Exp $");
 
 #define CHARSIZE(charset) ( ((charset)->min_bytes_per_char == (charset)->max_bytes_per_char )? \
 				(charset)->min_bytes_per_char : 0 )
@@ -1470,8 +1470,10 @@ collate2charset(int sql_collate, int lcid)
  * Get iconv information from a LCID (to support different column encoding under MSSQL2K)
  */
 TDSICONV *
-tds_iconv_from_collate(TDSSOCKET * tds, int sql_collate, int lcid)
+tds_iconv_from_collate(TDSSOCKET * tds, TDS_UCHAR collate[5])
 {
+	const int sql_collate = collate[4];
+	const int lcid = collate[1] * 256 + collate[0];
 	const char *charset = collate2charset(sql_collate, lcid);
 
 #if ENABLE_EXTRA_CHECKS
diff --git a/src/tds/token.c b/src/tds/token.c
index 021601f..3cb854b 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.369 2009/08/20 17:51:15 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.370 2009/08/20 17:53:06 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -1472,8 +1472,7 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		 */
 		tds_get_n(tds, curcol->column_collation, 5);
 		curcol->char_conv =
-			tds_iconv_from_collate(tds, curcol->column_collation[4],
-					       curcol->column_collation[1] * 256 + curcol->column_collation[0]);
+			tds_iconv_from_collate(tds, curcol->column_collation);
 	}
 
 	/* NOTE adjustements must be done after curcol->char_conv initialization */
@@ -1681,8 +1680,7 @@ tds_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int is_param)
 	if (IS_TDS8_PLUS(tds) && is_collate_type(curcol->on_server.column_type)) {
 		tds_get_n(tds, curcol->column_collation, 5);
 		curcol->char_conv =
-			tds_iconv_from_collate(tds, curcol->column_collation[4],
-					       curcol->column_collation[1] * 256 + curcol->column_collation[0]);
+			tds_iconv_from_collate(tds, curcol->column_collation);
 	}
 
 	/* Adjust column size according to client's encoding */
@@ -2012,8 +2010,7 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		colsize -= sizeof(v->collation);
 		info_len -= sizeof(v->collation);
 		curcol->char_conv =
-			tds_iconv_from_collate(tds, v->collation[4],
-					       v->collation[1] * 256 + v->collation[0]);
+			tds_iconv_from_collate(tds, v->collation);
 	}
 	/* special case for numeric */
 	if (is_numeric_type(type)) {

